"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var amqp_client_node_1 = require("amqp-client-node");
var routing_keys_name_1 = require("../utils/routing.keys.name");
var exchange_name_1 = require("../utils/exchange.name");
var event_name_1 = require("../utils/event.name");
var configurations_1 = require("../utils/configurations");
var events_1 = require("events");
var endpoint_queue_1 = require("../utils/endpoint.queue");
var resource_name_1 = require("../utils/resource.name");
var defaultOptionPub = {
    exchange: {
        durable: true,
        type: 'direct'
    }
};
var defaultOptionSub = {
    consumer: { noAck: true },
    exchange: {
        durable: true,
        type: 'direct'
    },
    queue: {
        durable: true
    },
    receiveFromYourself: false
};
var defaultOptionRpcServer = {
    consumer: { noAck: false },
    exchange: {
        durable: true,
        type: 'direct'
    },
    queue: {
        durable: true
    }
};
var defaultConnOpt = {
    retries: 0,
    interval: 1000
};
var OcariotRabbitMQClient = (function (_super) {
    __extends(OcariotRabbitMQClient, _super);
    function OcariotRabbitMQClient(appName, connParams, connOptions) {
        var _this = _super.call(this) || this;
        _this.appName = appName;
        _this.defaultOptionRpcClient = {
            exchange: {
                durable: true,
                type: 'direct'
            },
            rcpTimeout: 5000
        };
        _this.defaultConnConfig = {
            protocol: 'amqp',
            hostname: '127.0.0.1',
            port: 5672,
            username: 'guest',
            password: 'guest',
            vhost: 'ocariot'
        };
        _this._connConfig = _this.defaultConnConfig;
        if (typeof connParams === 'object') {
            _this._connConfig = __assign(__assign({}, _this._connConfig), connParams);
        }
        if (typeof connParams === 'string') {
            _this._connConfig = connParams.concat('/').concat(configurations_1.Configurations.VHOST);
        }
        _this._connOpt = __assign(__assign({}, defaultConnOpt), connOptions);
        if (connOptions) {
            if (connOptions.receiveFromYourself !== undefined)
                defaultOptionSub.receiveFromYourself = connOptions.receiveFromYourself;
            if (connOptions.rpcTimeout)
                _this.defaultOptionRpcClient.rcpTimeout = connOptions.rpcTimeout;
        }
        return _this;
    }
    OcariotRabbitMQClient.prototype.pubEventInitialization = function () {
        var _this = this;
        if (!this._pubConnection)
            return;
        this._pubConnection.on('disconnected', function () {
            _this.emit('pub_disconnected');
            _this._pubConnection = undefined;
            _this._pubConnectionInitialized = undefined;
        });
        this._pubConnection.on('trying', function () { return _this.emit('pub_trying_connection'); });
        this._pubConnection.on('reestablished', function () { return _this.emit('pub_reconnected'); });
        this._pubConnection.on('_error', function (err) { return _this.emit('pub_connection_error', err); });
    };
    OcariotRabbitMQClient.prototype.subEventInitialization = function () {
        var _this = this;
        if (!this._subConnection)
            return;
        this._subConnection.on('disconnected', function () {
            _this.emit('sub_disconnected');
            _this._subConnection = undefined;
            _this._subConnectionInitialized = undefined;
        });
        this._subConnection.on('trying', function () { return _this.emit('sub_trying_connection'); });
        this._subConnection.on('reestablished', function () { return _this.emit('sub_reconnected'); });
        this._subConnection.on('_error', function (err) { return _this.emit('sub_connection_error', err); });
    };
    OcariotRabbitMQClient.prototype.serverEventInitialization = function () {
        var _this = this;
        if (!this._serverConnection)
            return;
        this._serverConnection.on('disconnected', function () {
            _this.emit('rpc_server_disconnected');
            _this._serverConnection = undefined;
            _this._serverConnectionInitialized = undefined;
        });
        this._serverConnection.on('trying', function () { return _this.emit('rpc_server_trying_connection'); });
        this._serverConnection.on('reestablished', function () { return _this.emit('rpc_server_reconnected'); });
        this._serverConnection.on('_error', function (err) { return _this.emit('rpc_server_connection_error', err); });
    };
    OcariotRabbitMQClient.prototype.clientEventInitialization = function () {
        var _this = this;
        if (!this._clientConnection)
            return;
        this._clientConnection.on('disconnected', function () {
            _this.emit('rpc_client_disconnected');
            _this._clientConnection = undefined;
            _this._clientConnectionInitialized = undefined;
        });
        this._clientConnection.on('trying', function () { return _this.emit('rpc_client_connection'); });
        this._clientConnection.on('reestablished', function () { return _this.emit('rpc_client_reconnected'); });
        this._clientConnection.on('_error', function (err) { return _this.emit('rpc_client_connection_error', err); });
    };
    OcariotRabbitMQClient.prototype.logger = function (level, moduleName) {
        if (level === 'warn' || level === 'error' || level === 'info' || !level) {
            amqp_client_node_1.amqpClient.logger(level, moduleName);
        }
    };
    OcariotRabbitMQClient.prototype.close = function () {
        return __awaiter(this, void 0, void 0, function () {
            var err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 9, , 10]);
                        if (!this._pubConnection) return [3, 2];
                        return [4, this._pubConnection.close()];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        if (!this._subConnection) return [3, 4];
                        return [4, this._subConnection.close()];
                    case 3:
                        _a.sent();
                        _a.label = 4;
                    case 4:
                        if (!this._clientConnection) return [3, 6];
                        return [4, this._clientConnection.close()];
                    case 5:
                        _a.sent();
                        _a.label = 6;
                    case 6:
                        if (!this._serverConnection) return [3, 8];
                        return [4, this._serverConnection.close()];
                    case 7:
                        _a.sent();
                        _a.label = 8;
                    case 8:
                        this.removeAllListeners();
                        return [2, Promise.resolve()];
                    case 9:
                        err_1 = _a.sent();
                        return [2, Promise.reject(err_1)];
                    case 10: return [2];
                }
            });
        });
    };
    OcariotRabbitMQClient.prototype.pubConnection = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, err_2;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _b.trys.push([0, 4, , 5]);
                        if (!(!this._pubConnection && !this._pubConnectionInitialized)) return [3, 2];
                        this._pubConnectionInitialized = amqp_client_node_1.amqpClient.createConnection(this._connConfig, this._connOpt);
                        _a = this;
                        return [4, this._pubConnectionInitialized];
                    case 1:
                        _a._pubConnection = _b.sent();
                        this.pubEventInitialization();
                        this.emit('pub_connected');
                        _b.label = 2;
                    case 2: return [4, this._pubConnectionInitialized];
                    case 3:
                        _b.sent();
                        return [2, Promise.resolve()];
                    case 4:
                        err_2 = _b.sent();
                        this._pubConnection = undefined;
                        this._pubConnectionInitialized = undefined;
                        return [2, Promise.reject(err_2)];
                    case 5: return [2];
                }
            });
        });
    };
    OcariotRabbitMQClient.prototype.publish = function (exchangeName, routingKey, body) {
        return __awaiter(this, void 0, void 0, function () {
            var message, err_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4, this.pubConnection()];
                    case 1:
                        _a.sent();
                        message = { content: body };
                        return [2, this._pubConnection.pub(exchangeName, routingKey, message, defaultOptionPub)];
                    case 2:
                        err_3 = _a.sent();
                        return [2, Promise.reject(err_3)];
                    case 3: return [2];
                }
            });
        });
    };
    OcariotRabbitMQClient.prototype.pub = function (routingKey, body) {
        return __awaiter(this, void 0, void 0, function () {
            var message, err_4;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4, this.pubConnection()];
                    case 1:
                        _a.sent();
                        message = { content: body };
                        return [2, this._pubConnection.pub(exchange_name_1.ExchangeName.PERSONALIZED, routingKey, message, {
                                exchange: {
                                    durable: true,
                                    type: 'topic'
                                }
                            })];
                    case 2:
                        err_4 = _a.sent();
                        return [2, Promise.reject(err_4)];
                    case 3: return [2];
                }
            });
        });
    };
    OcariotRabbitMQClient.prototype.subConnection = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, err_5;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _b.trys.push([0, 4, , 5]);
                        if (!(!this._subConnection && !this._subConnectionInitialized)) return [3, 2];
                        this._subConnectionInitialized = amqp_client_node_1.amqpClient.createConnection(this._connConfig, this._connOpt);
                        _a = this;
                        return [4, this._subConnectionInitialized];
                    case 1:
                        _a._subConnection = _b.sent();
                        this.subEventInitialization();
                        this.emit('sub_connected');
                        _b.label = 2;
                    case 2: return [4, this._subConnectionInitialized];
                    case 3:
                        _b.sent();
                        return [2, Promise.resolve()];
                    case 4:
                        err_5 = _b.sent();
                        this._subConnection = undefined;
                        this._subConnectionInitialized = undefined;
                        return [2, Promise.reject(err_5)];
                    case 5: return [2];
                }
            });
        });
    };
    OcariotRabbitMQClient.prototype.sub = function (routingKey, callback) {
        return __awaiter(this, void 0, void 0, function () {
            var options, err_6;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4, this.subConnection()];
                    case 1:
                        _a.sent();
                        options = __assign(__assign({}, defaultOptionSub), {
                            exchange: { durable: true, type: 'topic' }
                        });
                        return [2, this._subConnection.sub(this.appName.concat(endpoint_queue_1.EndpointQueue.PERSONALIZED_SUB), exchange_name_1.ExchangeName.PERSONALIZED, routingKey, function (msg) { return callback(msg.content); }, options)];
                    case 2:
                        err_6 = _a.sent();
                        return [2, Promise.reject(err_6)];
                    case 3: return [2];
                }
            });
        });
    };
    OcariotRabbitMQClient.prototype.subscribe = function (exchangeName, routingKey, callback) {
        return __awaiter(this, void 0, void 0, function () {
            var err_7;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4, this.subConnection()];
                    case 1:
                        _a.sent();
                        return [2, this._subConnection.sub(this.appName, exchangeName, routingKey, function (msg) { return callback(msg.content); }, defaultOptionSub)];
                    case 2:
                        err_7 = _a.sent();
                        return [2, Promise.reject(err_7)];
                    case 3: return [2];
                }
            });
        });
    };
    OcariotRabbitMQClient.prototype.serverConnection = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, err_8;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _b.trys.push([0, 4, , 5]);
                        if (!(!this._serverConnection && !this._serverConnectionInitialized)) return [3, 2];
                        this._serverConnectionInitialized = amqp_client_node_1.amqpClient.createConnection(this._connConfig, this._connOpt);
                        _a = this;
                        return [4, this._serverConnectionInitialized];
                    case 1:
                        _a._serverConnection = _b.sent();
                        this.serverEventInitialization();
                        this.emit('rpc_server_connected');
                        _b.label = 2;
                    case 2: return [4, this._serverConnectionInitialized];
                    case 3:
                        _b.sent();
                        return [2, Promise.resolve()];
                    case 4:
                        err_8 = _b.sent();
                        this._serverConnection = undefined;
                        this._serverConnectionInitialized = undefined;
                        return [2, Promise.reject(err_8)];
                    case 5: return [2];
                }
            });
        });
    };
    OcariotRabbitMQClient.prototype.resource = function (exchangeName, name, func) {
        return __awaiter(this, void 0, void 0, function () {
            var server, err_9;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 4, , 5]);
                        return [4, this.serverConnection()];
                    case 1:
                        _a.sent();
                        server = this._serverConnection
                            .createRpcServer(this.appName.concat(endpoint_queue_1.EndpointQueue.RPC), exchangeName, [], defaultOptionRpcServer);
                        if (!server.addResource(name, func)) return [3, 3];
                        return [4, server.start()];
                    case 2: return [2, _a.sent()];
                    case 3: return [2, Promise.reject(new Error('Could not add resource to RPC Server. Resource already exists!'))];
                    case 4:
                        err_9 = _a.sent();
                        return [2, Promise.reject(err_9)];
                    case 5: return [2];
                }
            });
        });
    };
    OcariotRabbitMQClient.prototype.provide = function (name, func) {
        return __awaiter(this, void 0, void 0, function () {
            var server, err_10;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4, this.serverConnection()];
                    case 1:
                        _a.sent();
                        server = this._serverConnection
                            .createRpcServer(this.appName.concat(endpoint_queue_1.EndpointQueue.PERSONALIZED_RPC), exchange_name_1.ExchangeName.PERSONALIZED_RPC, [], defaultOptionRpcServer);
                        if (server.addResource(name, func))
                            return [2, server.start()];
                        return [2, Promise.reject(new Error('Could not add resource to RPC Server. Resource already exists!'))];
                    case 2:
                        err_10 = _a.sent();
                        return [2, Promise.reject(err_10)];
                    case 3: return [2];
                }
            });
        });
    };
    OcariotRabbitMQClient.prototype.getResource = function (name, params, callback) {
        if (!callback) {
            return this.getResourcePromise(exchange_name_1.ExchangeName.PERSONALIZED_RPC, name, params);
        }
        this.getResourceCallback(exchange_name_1.ExchangeName.PERSONALIZED_RPC, name, params, callback);
    };
    OcariotRabbitMQClient.prototype.requestResource = function (exchangeName, name, params, callback) {
        if (!callback) {
            return this.getResourcePromise(exchangeName, name, params);
        }
        this.getResourceCallback(exchangeName, name, params, callback);
    };
    OcariotRabbitMQClient.prototype.getResourceCallback = function (exchangeName, name, params, callback) {
        var _this = this;
        var time;
        if (!this._clientConnection) {
            new Promise(function (res) {
                time = setTimeout(res, _this.defaultOptionRpcClient.rcpTimeout);
            }).then(function () {
                return callback(new Error('rpc timed out'));
            });
        }
        if (!this._clientConnection && !this._clientConnectionInitialized) {
            this._clientConnectionInitialized = amqp_client_node_1.amqpClient.createConnection(this._connConfig, this._connOpt);
            this._clientConnectionInitialized
                .then(function (conn) {
                _this._clientConnection = conn;
                _this.clientEventInitialization();
                _this.emit('rpc_client_connected');
            })
                .catch(function () {
                _this._clientConnectionInitialized = undefined;
            });
        }
        if (!this._clientConnectionInitialized)
            return;
        this._clientConnectionInitialized
            .then(function () {
            clearTimeout(time);
            _this._clientConnection.rpcClient(exchangeName, name, params, callback, _this.defaultOptionRpcClient);
        })
            .catch(function (err) {
            callback(err, null);
        });
    };
    OcariotRabbitMQClient.prototype.getResourcePromise = function (exchangeName, name, params) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2, new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
                        var time_1, _a, err_11;
                        var _this = this;
                        return __generator(this, function (_b) {
                            switch (_b.label) {
                                case 0:
                                    _b.trys.push([0, 4, , 5]);
                                    if (!this._clientConnection) {
                                        new Promise(function (res) {
                                            time_1 = setTimeout(res, _this.defaultOptionRpcClient.rcpTimeout);
                                        }).then(function () {
                                            return reject(new Error('rpc timed out'));
                                        });
                                    }
                                    if (!(!this._clientConnection && !this._clientConnectionInitialized)) return [3, 2];
                                    this._clientConnectionInitialized = amqp_client_node_1.amqpClient.createConnection(this._connConfig, this._connOpt);
                                    _a = this;
                                    return [4, this._clientConnectionInitialized];
                                case 1:
                                    _a._clientConnection = _b.sent();
                                    this.clientEventInitialization();
                                    this.emit('rpc_client_connected');
                                    _b.label = 2;
                                case 2: return [4, this._clientConnectionInitialized];
                                case 3:
                                    _b.sent();
                                    clearTimeout(time_1);
                                    return [2, resolve(this._clientConnection.rpcClient(exchangeName, name, params, this.defaultOptionRpcClient))];
                                case 4:
                                    err_11 = _b.sent();
                                    this._clientConnectionInitialized = undefined;
                                    return [2, reject(err_11)];
                                case 5: return [2];
                            }
                        });
                    }); })];
            });
        });
    };
    OcariotRabbitMQClient.prototype.pubSavePhysicalActivity = function (activity) {
        var message = {
            event_name: event_name_1.EventName.SAVE_PHYSICAL_ACTIVITY_EVENT,
            timestamp: new Date().toISOString(),
            physicalactivity: activity
        };
        return this.publish(exchange_name_1.ExchangeName.ACTIVITY_TRACKING, routing_keys_name_1.RoutingKeysName.SAVE_PHYSICAL_ACTIVITIES, message);
    };
    OcariotRabbitMQClient.prototype.pubUpdatePhysicalActivity = function (activity) {
        var message = {
            event_name: event_name_1.EventName.UPDATE_PHYSICAL_ACTIVITY_EVENT,
            timestamp: new Date().toISOString(),
            physicalactivity: activity
        };
        return this.publish(exchange_name_1.ExchangeName.ACTIVITY_TRACKING, routing_keys_name_1.RoutingKeysName.UPDATE_PHYSICAL_ACTIVITIES, message);
    };
    OcariotRabbitMQClient.prototype.pubDeletePhysicalActivity = function (activity) {
        var message = {
            event_name: event_name_1.EventName.DELETE_PHYSICAL_ACTIVITY_EVENT,
            timestamp: new Date().toISOString(),
            physicalactivity: activity
        };
        return this.publish(exchange_name_1.ExchangeName.ACTIVITY_TRACKING, routing_keys_name_1.RoutingKeysName.DELETE_PHYSICAL_ACTIVITIES, message);
    };
    OcariotRabbitMQClient.prototype.pubSaveSleep = function (sleep) {
        var message = {
            event_name: event_name_1.EventName.SAVE_SLEEP_EVENT,
            timestamp: new Date().toISOString(),
            sleep: sleep
        };
        return this.publish(exchange_name_1.ExchangeName.ACTIVITY_TRACKING, routing_keys_name_1.RoutingKeysName.SAVE_SLEEP, message);
    };
    OcariotRabbitMQClient.prototype.pubUpdateSleep = function (sleep) {
        var message = {
            event_name: event_name_1.EventName.UPDATE_SLEEP_EVENT,
            timestamp: new Date().toISOString(),
            sleep: sleep
        };
        return this.publish(exchange_name_1.ExchangeName.ACTIVITY_TRACKING, routing_keys_name_1.RoutingKeysName.UPDATE_SLEEP, message);
    };
    OcariotRabbitMQClient.prototype.pubDeleteSleep = function (sleep) {
        var message = {
            event_name: event_name_1.EventName.DELETE_SLEEP_EVENT,
            timestamp: new Date().toISOString(),
            sleep: sleep
        };
        return this.publish(exchange_name_1.ExchangeName.ACTIVITY_TRACKING, routing_keys_name_1.RoutingKeysName.DELETE_SLEEP, message);
    };
    OcariotRabbitMQClient.prototype.pubSaveWeight = function (weight) {
        var message = {
            event_name: event_name_1.EventName.SAVE_WEIGHT_EVENT,
            timestamp: new Date().toISOString(),
            weight: weight
        };
        return this.publish(exchange_name_1.ExchangeName.ACTIVITY_TRACKING, routing_keys_name_1.RoutingKeysName.SAVE_WEIGHTS, message);
    };
    OcariotRabbitMQClient.prototype.pubDeleteWeight = function (weight) {
        var message = {
            event_name: event_name_1.EventName.DELETE_WEIGHT_EVENT,
            timestamp: new Date().toISOString(),
            weight: weight
        };
        return this.publish(exchange_name_1.ExchangeName.ACTIVITY_TRACKING, routing_keys_name_1.RoutingKeysName.DELETE_WEIGHTS, message);
    };
    OcariotRabbitMQClient.prototype.pubSaveEnvironment = function (environment) {
        var message = {
            event_name: event_name_1.EventName.SAVE_ENVIRONMENT_EVENT,
            timestamp: new Date().toISOString(),
            environment: environment
        };
        return this.publish(exchange_name_1.ExchangeName.ACTIVITY_TRACKING, routing_keys_name_1.RoutingKeysName.SAVE_ENVIRONMENTS, message);
    };
    OcariotRabbitMQClient.prototype.pubDeleteEnvironment = function (environment) {
        var message = {
            event_name: event_name_1.EventName.DELETE_ENVIRONMENT_EVENT,
            timestamp: new Date().toISOString(),
            environment: environment
        };
        return this.publish(exchange_name_1.ExchangeName.ACTIVITY_TRACKING, routing_keys_name_1.RoutingKeysName.DELETE_ENVIRONMENTS, message);
    };
    OcariotRabbitMQClient.prototype.pubSaveLog = function (log) {
        var message = {
            event_name: event_name_1.EventName.SAVE_LOG_EVENT,
            timestamp: new Date().toISOString(),
            log: log
        };
        return this.publish(exchange_name_1.ExchangeName.ACTIVITY_TRACKING, routing_keys_name_1.RoutingKeysName.SAVE_LOG, message);
    };
    OcariotRabbitMQClient.prototype.pubSaveChild = function (child) {
        var message = {
            event_name: event_name_1.EventName.SAVE_CHILD_EVENT,
            timestamp: new Date().toISOString(),
            child: child
        };
        return this.publish(exchange_name_1.ExchangeName.ACCOUNT, routing_keys_name_1.RoutingKeysName.SAVE_CHILDREN, message);
    };
    OcariotRabbitMQClient.prototype.pubUpdateChild = function (child) {
        var message = {
            event_name: event_name_1.EventName.UPDATE_CHILD_EVENT,
            timestamp: new Date().toISOString(),
            child: child
        };
        return this.publish(exchange_name_1.ExchangeName.ACCOUNT, routing_keys_name_1.RoutingKeysName.UPDATE_CHILDREN, message);
    };
    OcariotRabbitMQClient.prototype.pubUpdateFamily = function (family) {
        var message = {
            event_name: event_name_1.EventName.UPDATE_FAMILY_EVENT,
            timestamp: new Date().toISOString(),
            family: family
        };
        return this.publish(exchange_name_1.ExchangeName.ACCOUNT, routing_keys_name_1.RoutingKeysName.UPDATE_FAMILIES, message);
    };
    OcariotRabbitMQClient.prototype.pubUpdateEducator = function (educator) {
        var message = {
            event_name: event_name_1.EventName.UPDATE_EDUCATOR_EVENT,
            timestamp: new Date().toISOString(),
            educator: educator
        };
        return this.publish(exchange_name_1.ExchangeName.ACCOUNT, routing_keys_name_1.RoutingKeysName.UPDATE_EDUCATORS, message);
    };
    OcariotRabbitMQClient.prototype.pubUpdateHealthProfessional = function (healthprofessional) {
        var message = {
            event_name: event_name_1.EventName.UPDATE_HEALTH_PROFESSIONAL_EVENT,
            timestamp: new Date().toISOString(),
            healthprofessional: healthprofessional
        };
        return this.publish(exchange_name_1.ExchangeName.ACCOUNT, routing_keys_name_1.RoutingKeysName.UPDATE_HEALTH_PROFESSIONALS, message);
    };
    OcariotRabbitMQClient.prototype.pubUpdateApplication = function (application) {
        var message = {
            event_name: event_name_1.EventName.UPDATE_APPLICATION_EVENT,
            timestamp: new Date().toISOString(),
            application: application
        };
        return this.publish(exchange_name_1.ExchangeName.ACCOUNT, routing_keys_name_1.RoutingKeysName.UPDATE_APPLICATIONS, message);
    };
    OcariotRabbitMQClient.prototype.pubDeleteUser = function (user) {
        var message = {
            event_name: event_name_1.EventName.DELETE_USER_EVENT,
            timestamp: new Date().toISOString(),
            user: user
        };
        return this.publish(exchange_name_1.ExchangeName.ACCOUNT, routing_keys_name_1.RoutingKeysName.DELETE_USERS, message);
    };
    OcariotRabbitMQClient.prototype.pubDeleteInstitution = function (institution) {
        var message = {
            event_name: event_name_1.EventName.DELETE_INSTITUTION_EVENT,
            timestamp: new Date().toISOString(),
            institution: institution
        };
        return this.publish(exchange_name_1.ExchangeName.ACCOUNT, routing_keys_name_1.RoutingKeysName.DELETE_INSTITUTIONS, message);
    };
    OcariotRabbitMQClient.prototype.pubFitbitLastSync = function (fitbit) {
        var message = {
            event_name: event_name_1.EventName.LASTSYNC_FITBIT_FITBIT,
            timestamp: new Date().toISOString(),
            fitbit: fitbit
        };
        return this.publish(exchange_name_1.ExchangeName.DATA_SYNC, routing_keys_name_1.RoutingKeysName.LAST_SYNC_FIIBIT, message);
    };
    OcariotRabbitMQClient.prototype.pubFitbitAuthError = function (fitbit) {
        var message = {
            event_name: event_name_1.EventName.ERROR_FITBIT_AUTH_EVENT,
            timestamp: new Date().toISOString(),
            fitbit: fitbit
        };
        return this.publish(exchange_name_1.ExchangeName.DATA_SYNC, routing_keys_name_1.RoutingKeysName.ERROR_FITBIT_AUTH, message);
    };
    OcariotRabbitMQClient.prototype.pubFitbitRevoke = function (fitbit) {
        var message = {
            event_name: event_name_1.EventName.REVOKE_FITBIT_EVENT,
            timestamp: new Date().toISOString(),
            fitbit: fitbit
        };
        return this.publish(exchange_name_1.ExchangeName.DATA_SYNC, routing_keys_name_1.RoutingKeysName.REVOKE_FITBIT, message);
    };
    OcariotRabbitMQClient.prototype.pubSyncPhysicalActivity = function (activity) {
        var message = {
            event_name: event_name_1.EventName.SYNC_PHYSICAL_ACTIVITY_EVENT,
            timestamp: new Date().toISOString(),
            physicalactivity: activity
        };
        return this.publish(exchange_name_1.ExchangeName.DATA_SYNC, routing_keys_name_1.RoutingKeysName.SYNC_PHYSICAL_ACTIVITIES, message);
    };
    OcariotRabbitMQClient.prototype.pubSyncSleep = function (sleep) {
        var message = {
            event_name: event_name_1.EventName.SYNC_SLEEP_EVENT,
            timestamp: new Date().toISOString(),
            sleep: sleep
        };
        return this.publish(exchange_name_1.ExchangeName.DATA_SYNC, routing_keys_name_1.RoutingKeysName.SYNC_SLEEP, message);
    };
    OcariotRabbitMQClient.prototype.pubSyncWeight = function (weight) {
        var message = {
            event_name: event_name_1.EventName.SYNC_WEIGHT_EVENT,
            timestamp: new Date().toISOString(),
            weight: weight
        };
        return this.publish(exchange_name_1.ExchangeName.DATA_SYNC, routing_keys_name_1.RoutingKeysName.SYNC_WEIGHTS, message);
    };
    OcariotRabbitMQClient.prototype.pubSyncLog = function (log) {
        var message = {
            event_name: event_name_1.EventName.SYNC_LOG_EVENT,
            timestamp: new Date().toISOString(),
            log: log
        };
        return this.publish(exchange_name_1.ExchangeName.DATA_SYNC, routing_keys_name_1.RoutingKeysName.SYNC_LOGS, message);
    };
    OcariotRabbitMQClient.prototype.pubSaveFood = function (food) {
        var message = {
            event_name: event_name_1.EventName.SAVE_FOOD_EVENT,
            timestamp: new Date().toISOString(),
            food: food
        };
        return this.publish(exchange_name_1.ExchangeName.FOOD_TRACKING, routing_keys_name_1.RoutingKeysName.SAVE_FOODS, message);
    };
    OcariotRabbitMQClient.prototype.pubUpdateFood = function (food) {
        var message = {
            event_name: event_name_1.EventName.UPDATE_FOOD_EVENT,
            timestamp: new Date().toISOString(),
            food: food
        };
        return this.publish(exchange_name_1.ExchangeName.FOOD_TRACKING, routing_keys_name_1.RoutingKeysName.UPDATE_FOODS, message);
    };
    OcariotRabbitMQClient.prototype.subSavePhysicalActivity = function (callback) {
        return this.subscribe(exchange_name_1.ExchangeName.ACTIVITY_TRACKING, routing_keys_name_1.RoutingKeysName.SAVE_PHYSICAL_ACTIVITIES, callback);
    };
    OcariotRabbitMQClient.prototype.subUpdatePhysicalActivity = function (callback) {
        return this.subscribe(exchange_name_1.ExchangeName.ACTIVITY_TRACKING, routing_keys_name_1.RoutingKeysName.UPDATE_PHYSICAL_ACTIVITIES, callback);
    };
    OcariotRabbitMQClient.prototype.subDeletePhysicalActivity = function (callback) {
        return this.subscribe(exchange_name_1.ExchangeName.ACTIVITY_TRACKING, routing_keys_name_1.RoutingKeysName.DELETE_PHYSICAL_ACTIVITIES, callback);
    };
    OcariotRabbitMQClient.prototype.subSaveSleep = function (callback) {
        return this.subscribe(exchange_name_1.ExchangeName.ACTIVITY_TRACKING, routing_keys_name_1.RoutingKeysName.SAVE_SLEEP, callback);
    };
    OcariotRabbitMQClient.prototype.subUpdateSleep = function (callback) {
        return this.subscribe(exchange_name_1.ExchangeName.ACTIVITY_TRACKING, routing_keys_name_1.RoutingKeysName.UPDATE_SLEEP, callback);
    };
    OcariotRabbitMQClient.prototype.subDeleteSleep = function (callback) {
        return this.subscribe(exchange_name_1.ExchangeName.ACTIVITY_TRACKING, routing_keys_name_1.RoutingKeysName.DELETE_SLEEP, callback);
    };
    OcariotRabbitMQClient.prototype.subSaveWeight = function (callback) {
        return this.subscribe(exchange_name_1.ExchangeName.ACTIVITY_TRACKING, routing_keys_name_1.RoutingKeysName.SAVE_WEIGHTS, callback);
    };
    OcariotRabbitMQClient.prototype.subDeleteWeight = function (callback) {
        return this.subscribe(exchange_name_1.ExchangeName.ACTIVITY_TRACKING, routing_keys_name_1.RoutingKeysName.DELETE_WEIGHTS, callback);
    };
    OcariotRabbitMQClient.prototype.subSaveEnvironment = function (callback) {
        return this.subscribe(exchange_name_1.ExchangeName.ACTIVITY_TRACKING, routing_keys_name_1.RoutingKeysName.SAVE_ENVIRONMENTS, callback);
    };
    OcariotRabbitMQClient.prototype.subDeleteEnvironment = function (callback) {
        return this.subscribe(exchange_name_1.ExchangeName.ACTIVITY_TRACKING, routing_keys_name_1.RoutingKeysName.DELETE_ENVIRONMENTS, callback);
    };
    OcariotRabbitMQClient.prototype.subSaveLog = function (callback) {
        return this.subscribe(exchange_name_1.ExchangeName.ACTIVITY_TRACKING, routing_keys_name_1.RoutingKeysName.SAVE_LOG, callback);
    };
    OcariotRabbitMQClient.prototype.subSaveChild = function (callback) {
        return this.subscribe(exchange_name_1.ExchangeName.ACCOUNT, routing_keys_name_1.RoutingKeysName.SAVE_CHILDREN, callback);
    };
    OcariotRabbitMQClient.prototype.subUpdateChild = function (callback) {
        return this.subscribe(exchange_name_1.ExchangeName.ACCOUNT, routing_keys_name_1.RoutingKeysName.UPDATE_CHILDREN, callback);
    };
    OcariotRabbitMQClient.prototype.subUpdateFamily = function (callback) {
        return this.subscribe(exchange_name_1.ExchangeName.ACCOUNT, routing_keys_name_1.RoutingKeysName.UPDATE_FAMILIES, callback);
    };
    OcariotRabbitMQClient.prototype.subUpdateEducator = function (callback) {
        return this.subscribe(exchange_name_1.ExchangeName.ACCOUNT, routing_keys_name_1.RoutingKeysName.UPDATE_EDUCATORS, callback);
    };
    OcariotRabbitMQClient.prototype.subUpdateHealthProfessional = function (callback) {
        return this.subscribe(exchange_name_1.ExchangeName.ACCOUNT, routing_keys_name_1.RoutingKeysName.UPDATE_HEALTH_PROFESSIONALS, callback);
    };
    OcariotRabbitMQClient.prototype.subUpdateApplication = function (callback) {
        return this.subscribe(exchange_name_1.ExchangeName.ACCOUNT, routing_keys_name_1.RoutingKeysName.UPDATE_APPLICATIONS, callback);
    };
    OcariotRabbitMQClient.prototype.subDeleteUser = function (callback) {
        return this.subscribe(exchange_name_1.ExchangeName.ACCOUNT, routing_keys_name_1.RoutingKeysName.DELETE_USERS, callback);
    };
    OcariotRabbitMQClient.prototype.subDeleteInstitution = function (callback) {
        return this.subscribe(exchange_name_1.ExchangeName.ACCOUNT, routing_keys_name_1.RoutingKeysName.DELETE_INSTITUTIONS, callback);
    };
    OcariotRabbitMQClient.prototype.subFitbitLastSync = function (callback) {
        return this.subscribe(exchange_name_1.ExchangeName.DATA_SYNC, routing_keys_name_1.RoutingKeysName.LAST_SYNC_FIIBIT, callback);
    };
    OcariotRabbitMQClient.prototype.subFitbitAuthError = function (callback) {
        return this.subscribe(exchange_name_1.ExchangeName.DATA_SYNC, routing_keys_name_1.RoutingKeysName.ERROR_FITBIT_AUTH, callback);
    };
    OcariotRabbitMQClient.prototype.subFitbitRevoke = function (callback) {
        return this.subscribe(exchange_name_1.ExchangeName.DATA_SYNC, routing_keys_name_1.RoutingKeysName.REVOKE_FITBIT, callback);
    };
    OcariotRabbitMQClient.prototype.subSyncPhysicalActivity = function (callback) {
        return this.subscribe(exchange_name_1.ExchangeName.DATA_SYNC, routing_keys_name_1.RoutingKeysName.SYNC_PHYSICAL_ACTIVITIES, callback);
    };
    OcariotRabbitMQClient.prototype.subSyncSleep = function (callback) {
        return this.subscribe(exchange_name_1.ExchangeName.DATA_SYNC, routing_keys_name_1.RoutingKeysName.SYNC_SLEEP, callback);
    };
    OcariotRabbitMQClient.prototype.subSyncWeight = function (callback) {
        return this.subscribe(exchange_name_1.ExchangeName.DATA_SYNC, routing_keys_name_1.RoutingKeysName.SYNC_WEIGHTS, callback);
    };
    OcariotRabbitMQClient.prototype.subSyncLog = function (callback) {
        return this.subscribe(exchange_name_1.ExchangeName.DATA_SYNC, routing_keys_name_1.RoutingKeysName.SYNC_LOGS, callback);
    };
    OcariotRabbitMQClient.prototype.subSaveFood = function (callback) {
        return this.subscribe(exchange_name_1.ExchangeName.FOOD_TRACKING, routing_keys_name_1.RoutingKeysName.SAVE_FOODS, callback);
    };
    OcariotRabbitMQClient.prototype.subUpdateFood = function (callback) {
        return this.subscribe(exchange_name_1.ExchangeName.FOOD_TRACKING, routing_keys_name_1.RoutingKeysName.UPDATE_FOODS, callback);
    };
    OcariotRabbitMQClient.prototype.providePhysicalActivities = function (listener) {
        return this.resource(exchange_name_1.ExchangeName.ACTIVITY_TRACKING_RPC, resource_name_1.ResourceName.PHYSICAL_ACTIVITIES, listener);
    };
    OcariotRabbitMQClient.prototype.provideSleep = function (listener) {
        return this.resource(exchange_name_1.ExchangeName.ACTIVITY_TRACKING_RPC, resource_name_1.ResourceName.SLEEP, listener);
    };
    OcariotRabbitMQClient.prototype.provideWeights = function (listener) {
        return this.resource(exchange_name_1.ExchangeName.ACTIVITY_TRACKING_RPC, resource_name_1.ResourceName.WEIGHTS, listener);
    };
    OcariotRabbitMQClient.prototype.provideEnvironments = function (listener) {
        return this.resource(exchange_name_1.ExchangeName.ACTIVITY_TRACKING_RPC, resource_name_1.ResourceName.ENVIRONMENTS, listener);
    };
    OcariotRabbitMQClient.prototype.provideLogs = function (listener) {
        return this.resource(exchange_name_1.ExchangeName.ACTIVITY_TRACKING_RPC, resource_name_1.ResourceName.LOGS, listener);
    };
    OcariotRabbitMQClient.prototype.provideChildren = function (listener) {
        return this.resource(exchange_name_1.ExchangeName.ACCOUNT_RPC, resource_name_1.ResourceName.CHILDREN, listener);
    };
    OcariotRabbitMQClient.prototype.provideFamilies = function (listener) {
        return this.resource(exchange_name_1.ExchangeName.ACCOUNT_RPC, resource_name_1.ResourceName.FAMILIES, listener);
    };
    OcariotRabbitMQClient.prototype.provideFamilyChildren = function (listener) {
        return this.resource(exchange_name_1.ExchangeName.ACCOUNT_RPC, resource_name_1.ResourceName.FAMILY_CHILDREN, listener);
    };
    OcariotRabbitMQClient.prototype.provideEducators = function (listener) {
        return this.resource(exchange_name_1.ExchangeName.ACCOUNT_RPC, resource_name_1.ResourceName.EDUCATORS, listener);
    };
    OcariotRabbitMQClient.prototype.provideEducatorChildrenGroups = function (listener) {
        return this.resource(exchange_name_1.ExchangeName.ACCOUNT_RPC, resource_name_1.ResourceName.EDUCATORS_CHILDRES_GROUPS, listener);
    };
    OcariotRabbitMQClient.prototype.provideHealthProfessionals = function (listener) {
        return this.resource(exchange_name_1.ExchangeName.ACCOUNT_RPC, resource_name_1.ResourceName.HEALTH_PROFESSIONALS, listener);
    };
    OcariotRabbitMQClient.prototype.provideHealthProfessionalChildrenGroups = function (listener) {
        return this.resource(exchange_name_1.ExchangeName.ACCOUNT_RPC, resource_name_1.ResourceName.HEALTH_PROFESSIONAL_CHILDREN_GROUPS, listener);
    };
    OcariotRabbitMQClient.prototype.provideApplications = function (listener) {
        return this.resource(exchange_name_1.ExchangeName.ACCOUNT_RPC, resource_name_1.ResourceName.APPLICATIONS, listener);
    };
    OcariotRabbitMQClient.prototype.provideInstitutions = function (listener) {
        return this.resource(exchange_name_1.ExchangeName.ACCOUNT_RPC, resource_name_1.ResourceName.INSTITUTIONS, listener);
    };
    OcariotRabbitMQClient.prototype.provideEducatorsFromChild = function (listener) {
        return this.resource(exchange_name_1.ExchangeName.ACCOUNT_RPC, resource_name_1.ResourceName.EDUCATORS_FROM_CHILD, listener);
    };
    OcariotRabbitMQClient.prototype.provideHealthProfessionalsFromChild = function (listener) {
        return this.resource(exchange_name_1.ExchangeName.ACCOUNT_RPC, resource_name_1.ResourceName.HEALTH_PROFESSIONALS_FROM_CHILD, listener);
    };
    OcariotRabbitMQClient.prototype.provideFoods = function (listener) {
        return this.resource(exchange_name_1.ExchangeName.FOOD_TRACKING_RPC, resource_name_1.ResourceName.FOODS, listener);
    };
    OcariotRabbitMQClient.prototype.getPhysicalActivities = function (query, callback) {
        if (!callback) {
            return this.requestResource(exchange_name_1.ExchangeName.ACTIVITY_TRACKING_RPC, resource_name_1.ResourceName.PHYSICAL_ACTIVITIES, [query]);
        }
        this.requestResource(exchange_name_1.ExchangeName.ACTIVITY_TRACKING_RPC, resource_name_1.ResourceName.PHYSICAL_ACTIVITIES, [query], callback);
    };
    OcariotRabbitMQClient.prototype.getSleep = function (query, callback) {
        if (!callback) {
            return this.requestResource(exchange_name_1.ExchangeName.ACTIVITY_TRACKING_RPC, resource_name_1.ResourceName.SLEEP, [query]);
        }
        this.requestResource(exchange_name_1.ExchangeName.ACTIVITY_TRACKING_RPC, resource_name_1.ResourceName.SLEEP, [query], callback);
    };
    OcariotRabbitMQClient.prototype.getWeights = function (query, callback) {
        if (!callback) {
            return this.requestResource(exchange_name_1.ExchangeName.ACTIVITY_TRACKING_RPC, resource_name_1.ResourceName.WEIGHTS, [query]);
        }
        this.requestResource(exchange_name_1.ExchangeName.ACTIVITY_TRACKING_RPC, resource_name_1.ResourceName.WEIGHTS, [query], callback);
    };
    OcariotRabbitMQClient.prototype.getEnvironments = function (query, callback) {
        if (!callback) {
            return this.requestResource(exchange_name_1.ExchangeName.ACTIVITY_TRACKING_RPC, resource_name_1.ResourceName.ENVIRONMENTS, [query]);
        }
        this.requestResource(exchange_name_1.ExchangeName.ACTIVITY_TRACKING_RPC, resource_name_1.ResourceName.ENVIRONMENTS, [query], callback);
    };
    OcariotRabbitMQClient.prototype.getLogs = function (childId, dateStart, dateEnd, callback) {
        if (!callback) {
            return this.requestResource(exchange_name_1.ExchangeName.ACTIVITY_TRACKING_RPC, resource_name_1.ResourceName.LOGS, [childId, dateStart, dateEnd]);
        }
        this.requestResource(exchange_name_1.ExchangeName.ACTIVITY_TRACKING_RPC, resource_name_1.ResourceName.LOGS, [childId, dateStart, dateEnd], callback);
    };
    OcariotRabbitMQClient.prototype.getChildren = function (query, callback) {
        if (!callback) {
            return this.requestResource(exchange_name_1.ExchangeName.ACCOUNT_RPC, resource_name_1.ResourceName.CHILDREN, [query]);
        }
        this.requestResource(exchange_name_1.ExchangeName.ACCOUNT_RPC, resource_name_1.ResourceName.CHILDREN, [query], callback);
    };
    OcariotRabbitMQClient.prototype.getFamilies = function (query, callback) {
        if (!callback) {
            return this.requestResource(exchange_name_1.ExchangeName.ACCOUNT_RPC, resource_name_1.ResourceName.FAMILIES, [query]);
        }
        this.requestResource(exchange_name_1.ExchangeName.ACCOUNT_RPC, resource_name_1.ResourceName.FAMILIES, [query], callback);
    };
    OcariotRabbitMQClient.prototype.getFamilyChildren = function (familyId, callback) {
        if (!callback) {
            return this.requestResource(exchange_name_1.ExchangeName.ACCOUNT_RPC, resource_name_1.ResourceName.FAMILY_CHILDREN, [familyId]);
        }
        this.requestResource(exchange_name_1.ExchangeName.ACCOUNT_RPC, resource_name_1.ResourceName.FAMILY_CHILDREN, [familyId], callback);
    };
    OcariotRabbitMQClient.prototype.getEducators = function (query, callback) {
        if (!callback) {
            return this.requestResource(exchange_name_1.ExchangeName.ACCOUNT_RPC, resource_name_1.ResourceName.EDUCATORS, [query]);
        }
        this.requestResource(exchange_name_1.ExchangeName.ACCOUNT_RPC, resource_name_1.ResourceName.EDUCATORS, [query], callback);
    };
    OcariotRabbitMQClient.prototype.getEducatorChildrenGroups = function (educatorId, callback) {
        if (!callback) {
            return this.requestResource(exchange_name_1.ExchangeName.ACCOUNT_RPC, resource_name_1.ResourceName.EDUCATORS_CHILDRES_GROUPS, [educatorId]);
        }
        this.requestResource(exchange_name_1.ExchangeName.ACCOUNT_RPC, resource_name_1.ResourceName.EDUCATORS_CHILDRES_GROUPS, [educatorId], callback);
    };
    OcariotRabbitMQClient.prototype.getHealthProfessionals = function (query, callback) {
        if (!callback) {
            return this.requestResource(exchange_name_1.ExchangeName.ACCOUNT_RPC, resource_name_1.ResourceName.HEALTH_PROFESSIONALS, [query]);
        }
        this.requestResource(exchange_name_1.ExchangeName.ACCOUNT_RPC, resource_name_1.ResourceName.HEALTH_PROFESSIONALS, [query], callback);
    };
    OcariotRabbitMQClient.prototype.getHealthProfessionalChildrenGroups = function (healthProfessionalId, callback) {
        if (!callback) {
            return this.requestResource(exchange_name_1.ExchangeName.ACCOUNT_RPC, resource_name_1.ResourceName.HEALTH_PROFESSIONAL_CHILDREN_GROUPS, [healthProfessionalId]);
        }
        this.requestResource(exchange_name_1.ExchangeName.ACCOUNT_RPC, resource_name_1.ResourceName.HEALTH_PROFESSIONAL_CHILDREN_GROUPS, [healthProfessionalId], callback);
    };
    OcariotRabbitMQClient.prototype.getApplications = function (query, callback) {
        if (!callback) {
            return this.requestResource(exchange_name_1.ExchangeName.ACCOUNT_RPC, resource_name_1.ResourceName.APPLICATIONS, [query]);
        }
        this.requestResource(exchange_name_1.ExchangeName.ACCOUNT_RPC, resource_name_1.ResourceName.APPLICATIONS, [query], callback);
    };
    OcariotRabbitMQClient.prototype.getInstitutions = function (query, callback) {
        if (!callback) {
            return this.requestResource(exchange_name_1.ExchangeName.ACCOUNT_RPC, resource_name_1.ResourceName.INSTITUTIONS, [query]);
        }
        this.requestResource(exchange_name_1.ExchangeName.ACCOUNT_RPC, resource_name_1.ResourceName.INSTITUTIONS, [query], callback);
    };
    OcariotRabbitMQClient.prototype.getEducatorsFromChild = function (childId, callback) {
        if (!callback) {
            return this.requestResource(exchange_name_1.ExchangeName.ACCOUNT_RPC, resource_name_1.ResourceName.EDUCATORS_FROM_CHILD, [childId]);
        }
        this.requestResource(exchange_name_1.ExchangeName.ACCOUNT_RPC, resource_name_1.ResourceName.EDUCATORS_FROM_CHILD, [childId], callback);
    };
    OcariotRabbitMQClient.prototype.getHealthProfessionalsFromChild = function (childId, callback) {
        if (!callback) {
            return this.requestResource(exchange_name_1.ExchangeName.ACCOUNT_RPC, resource_name_1.ResourceName.HEALTH_PROFESSIONALS_FROM_CHILD, [childId]);
        }
        this.requestResource(exchange_name_1.ExchangeName.ACCOUNT_RPC, resource_name_1.ResourceName.HEALTH_PROFESSIONALS_FROM_CHILD, [childId], callback);
    };
    OcariotRabbitMQClient.prototype.getFoods = function (childId, dateStart, dateEnd, callback) {
        if (!callback) {
            return this.requestResource(exchange_name_1.ExchangeName.FOOD_TRACKING_RPC, resource_name_1.ResourceName.FOODS, [childId, dateStart, dateEnd]);
        }
        this.requestResource(exchange_name_1.ExchangeName.FOOD_TRACKING_RPC, resource_name_1.ResourceName.FOODS, [childId, dateStart, dateEnd], callback);
    };
    return OcariotRabbitMQClient;
}(events_1.EventEmitter));
exports.OcariotRabbitMQClient = OcariotRabbitMQClient;
