import { IRpcClient } from './rpc.client.interface';
export interface IOcariotRpcClient extends IRpcClient {
    getPhysicalActivities(query: string, callback: (err: any, result: any) => void): void;
    getPhysicalActivities(query?: string): Promise<any>;
    getSleep(query: string, callback: (err: any, result: any) => void): void;
    getSleep(query?: string): Promise<any>;
    getWeights(query: string, callback: (err: any, result: any) => void): void;
    getWeights(query?: string): Promise<any>;
    getEnvironments(query: string, callback: (err: any, result: any) => void): void;
    getEnvironments(query?: string): Promise<any>;
    getLogs(childId: string, dateStart: string, dateEnd: string, callback: (err: any, result: any) => void): void;
    getLogs(childId: string, dateStart: string, dateEnd: string): Promise<any>;
    getChildren(query: string, callback: (err: any, children: any) => void): void;
    getChildren(query?: string): Promise<any>;
    getFamilies(query: string, callback: (err: any, families: any) => void): void;
    getFamilies(query?: string): Promise<any>;
    getFamilyChildren(familyId: string, callback: (err: any, children: any) => void): void;
    getFamilyChildren(familyId: string): Promise<any>;
    getEducators(query: string, callback: (err: any, educators: any) => void): void;
    getEducators(query?: string): Promise<any>;
    getEducatorChildrenGroups(educatorId: string, callback: (err: any, childrenGroups: any) => void): void;
    getEducatorChildrenGroups(educatorId: string): Promise<any>;
    getHealthProfessionals(query: string, callback: (err: any, healthProfessionals: any) => void): void;
    getHealthProfessionals(query?: string): Promise<any>;
    getHealthProfessionalChildrenGroups(healthProfessionalId: string, callback: (err: any, childrenGroups: any) => void): void;
    getHealthProfessionalChildrenGroups(healthProfessionalId: string): Promise<any>;
    getApplications(query: string, callback: (err: any, applications: any) => void): void;
    getApplications(query?: string): Promise<any>;
    getInstitutions(query: string, callback: (err: any, institutions: any) => void): void;
    getInstitutions(query?: string): Promise<any>;
    getEducatorsFromChild(childId: string): Promise<any>;
    getEducatorsFromChild(childId: string, callback: (err: any, educators: any) => void): void;
    getHealthProfessionalsFromChild(childId: string): Promise<any>;
    getHealthProfessionalsFromChild(childId: string, callback: (err: any, healthProfessionals: any) => void): void;
    getFoods(childId: string, dateStart: string, dateEnd: string): Promise<any>;
}
